/*------------------------------ color_calls.c -------------------------------*/
/* Copyright 1989 Brown University -- Jeffrey Vogel                           */
/*----------------------------------------------------------------------------*/


#include "qd_local.h"

/*--------------------------------- SetColor ---------------------------------*/
/*----------------------------------------------------------------------------*/

void
SetColor(color)
int   color;
{
   unsigned long pixel;

   /*** error checks ***/
   if (!QDrunning) {
      QDerror("ERROR SetColor: QuickDraw not initialized.");
      return;
   }
   if (!QDcolor) {
      QDerror("ERROR SetColor: Not a color display.");
      return;
   }

   if ((color < 0) || (color > QD__MAX_COLOR)) {
      QDerror("ERROR SetColor: Invalid color value.");
      return;
   }
 
   /*** allocate color ***/
   switch (color) {
    case blackColor:
      pixel = QDcolor__black;
      break;
    case magentaColor:
      pixel = QDcolor__magenta;
      break;
    case cyanColor:
      pixel = QDcolor__cyan;
      break;
    case yellowColor:
      pixel = QDcolor__yellow;
      break;
    case redColor:
      pixel = QDcolor__red;
      break;            
    case greenColor:
      pixel = QDcolor__green;
      break;
    case blueColor:
      pixel = QDcolor__blue;
      break;
    case whiteColor:
      pixel = QDcolor__white;
      break;
   }
   
   XSetForeground(QDdisplay, QDgc, pixel);
}





/*---------------------------------- PenPat ----------------------------------*/
/*----------------------------------------------------------------------------*/

void
PenPat(pat)
Patterns  pat;
{
   /*** error checks ***/
   if (!QDrunning) {
      QDerror("ERROR PenPat: QuickDraw not initialized.");
      return;
   }
   if ((pat < white) || (pat > black)) {
      QDerror("ERROR PenPat: Illegal pattern specification.");
      return;
   }

   switch (pat) {
    case ltGray: XSetFillStyle(QDdisplay, QDgc, FillStippled);
                 XSetStipple(QDdisplay, QDgc, QDstipple__ltGray);
                 break;
    case gray:   XSetFillStyle(QDdisplay, QDgc, FillStippled);
                 XSetStipple(QDdisplay, QDgc, QDstipple__gray);
                 break;
    case dkGray: XSetFillStyle(QDdisplay, QDgc, FillStippled);
                 XSetStipple(QDdisplay, QDgc, QDstipple__dkGray);
                 break;
    case white:  XSetFillStyle(QDdisplay, QDgc, FillStippled);
                 XSetStipple(QDdisplay, QDgc, QDstipple__white);
                 break;
    case black:  XSetFillStyle(QDdisplay, QDgc, FillStippled);
                 XSetStipple(QDdisplay, QDgc, QDstipple__black);
                 break;
   }
}































