/*--------------------------------- calls.c ----------------------------------*/
/* Copyright 1989 Brown University -- Jeffrey Vogel                           */
/*----------------------------------------------------------------------------*/

/*--------------------------------- Includes ---------------------------------*/
/*----------------------------------------------------------------------------*/

#include "qd_local.h"


/*-------------------------------- DrawString --------------------------------*/
/*----------------------------------------------------------------------------*/

void
DrawString(string, x, y)
char   *string;
int    x, y;
{
   if (!QDrunning) {
      QDerror("ERROR DrawText: QuickDraw not initialized.");
      return;
   }

   XDrawString(QDdisplay, QDwindow, QDgc, x, y, string, strlen(string));
   XFlush(QDdisplay);
}


/*----------------------------- QueryStringSize ------------------------------*/
/*----------------------------------------------------------------------------*/

void
QueryStringSize(string, width, height)
char   *string;
int    *width, *height;
{
   register int i;

   /*** error check ***/
   if (!QDrunning) {
      QDerror("ERROR QueryStringSize: QuickDraw not initialized.");
      return;
   }

   /*** find the font ***/
   i = 0;
   while (QDfonts[i] != QDgcValues.font)
      i++;
 
   *height = QDfontInfo[i]->ascent;
   *width  = XTextWidth(QDfontInfo[i], string, strlen(string));
}














/*------------------------------- For Pascal  --------------------------------*/
/*----------------------------------------------------------------------------*/

#define TEXT__STRING_LENGTH 128

typedef struct {
   char   a[TEXT__STRING_LENGTH];
} Stringarray;


static
void
ConvertTheString(s)
char  *s;
{
   register int i;

   s[TEXT__STRING_LENGTH-1] = '\0';     

   for (i = TEXT__STRING_LENGTH - 2; i >= 0; i--) {
      if (s[i] == ' ')
         s[i] = '\0';
      else if (s[i] != '\0')
         return;
   }
}

void
DrawPascalString(string, x, y)
Stringarray string;
int         x, y;
{
   ConvertTheString(string.a);
   DrawString(string.a, x, y);
}

void
QueryPascalStringSize(string, width, height)
Stringarray   string;
int    *width, *height;
{
   ConvertTheString(string.a);
   QueryStringSize(string.a, width, height);
}






















